Index: /LMDZ6/branches/SETHET_DECOUPLE/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/DefLists/field_def_lmdz.xml	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/DefLists/field_def_lmdz.xml	(revision 4800)
@@ -590,4 +590,17 @@
         <field id="ozone"    long_name="Ozone mole fraction"    unit="-" />
         <field id="ozone_daylight"    long_name="Daylight ozone mole fraction"    unit="-" />
+         <field id="dAIBCM_vdf"    long_name="Boundary layer of AIBCM"    unit="kg/kg/s" />
+         <field id="dASBCM_vdf"    long_name="Boundary layer of ASBCM"    unit="kg/kg/s" />
+         <field id="dASAPp1a_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dASAPp2a_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dASARp1a_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dASARp2a_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dAIPOMM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dASPOMM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dCIDUSTM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dASSSM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dCSSSM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+         <field id="dSSSSM_vdf"    long_name="Boundary layer"    unit="kg/kg/s" />
+
         <field id="upwd"    long_name="saturated updraft"    unit="kg/m2/s" />
         <field id="ep"    long_name="ep"    unit="su" />
Index: /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histday_lmdz.xml
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histday_lmdz.xml	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histday_lmdz.xml	(revision 4800)
@@ -615,4 +615,17 @@
                 <field field_ref="l_mixmin_sic" level="10" />
                 <field field_ref="ozone_daylight" level="10" />
+                <field field_ref="dAIBCM_vdf" level="5" />
+                <field field_ref="dASBCM_vdf" level="5" />
+                <field field_ref="dASAPp1a_vdf" level="5" />
+                <field field_ref="dASAPp2a_vdf" level="5" />
+                <field field_ref="dASARp1a_vdf" level="5" />
+                <field field_ref="dASARp2a_vdf" level="5" />
+                <field field_ref="dASPOMM_vdf" level="5" />
+                <field field_ref="dAIPOMM_vdf" level="5" />
+                <field field_ref="dCIDUSTM_vdf" level="5" />
+                <field field_ref="dASSSM_vdf" level="5" />
+                <field field_ref="dCSSSM_vdf" level="5" />
+                <field field_ref="dSSSSM_vdf" level="5" />
+                
             </field_group>
             <field_group operation="average" grid_ref="grid_out_presinter">
Index: /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histmth_lmdz.xml
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histmth_lmdz.xml	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/DefLists/file_def_histmth_lmdz.xml	(revision 4800)
@@ -550,4 +550,17 @@
                 <field field_ref="ozone" level="3" />
                 <field field_ref="ozone_daylight" level="2" />
+                 <field field_ref="dAIBCM_vdf" level="5" />
+                 <field field_ref="dASBCM_vdf" level="5" />
+                 <field field_ref="dASAPp1a_vdf" level="5" />
+                 <field field_ref="dASAPp2a_vdf" level="5" />
+                 <field field_ref="dASARp1a_vdf" level="5" />
+                 <field field_ref="dASARp2a_vdf" level="5" />
+                 <field field_ref="dASPOMM_vdf" level="5" />
+                 <field field_ref="dAIPOMM_vdf" level="5" />
+                 <field field_ref="dCIDUSTM_vdf" level="5" />
+                 <field field_ref="dASSSM_vdf" level="5" />
+                 <field field_ref="dCSSSM_vdf" level="5" />
+                 <field field_ref="dSSSSM_vdf" level="5" />
+
                 <field field_ref="upwd" level="7" />
                 <field field_ref="ep" level="7" />
Index: /LMDZ6/branches/SETHET_DECOUPLE/arch/arch-X64_IRENE.fcm
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/arch/arch-X64_IRENE.fcm	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/arch/arch-X64_IRENE.fcm	(revision 4800)
@@ -14,5 +14,5 @@
 %MPI_FFLAGS
 %OMP_FFLAGS          -qopenmp
-%BASE_LD             -i4 -r8 -auto -L/ccc/products/mkl-17.0.4.196/intel--17.0.4.196__openmpi--2.0.2/default/17.0.4.196/mkl/lib/intel64 -lmkl_intel_lp64 -lmkl_core -lmkl_sequential -lpthread
+%BASE_LD -i4 -r8 -auto -L/ccc/products/mkl-20.0.0/system/default/20.0.0/mkl/lib/intel64 -lmkl_intel_lp64 -lmkl_core -lmkl_sequential -lpthread 
 %MPI_LD
 %OMP_LD              -qopenmp
Index: /LMDZ6/branches/SETHET_DECOUPLE/libf/dyn3dmem/dynredem_loc.F90
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/libf/dyn3dmem/dynredem_loc.F90	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/libf/dyn3dmem/dynredem_loc.F90	(revision 4800)
@@ -11,5 +11,6 @@
   USE infotrac
   USE netcdf, ONLY: NF90_CREATE, NF90_DEF_DIM, NF90_INQ_VARID, NF90_GLOBAL,    &
-                    NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER
+                    NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER, &
+                    NF90_64BIT_OFFSET
   USE dynredem_mod, ONLY: cre_var, put_var, err, modname, fil
   USE comvert_mod, ONLY: ap,bp,aps,bps,presnivs,pseudoalt,pa,preff, &
@@ -110,5 +111,5 @@
 
 !--- File creation
-  CALL err(NF90_CREATE(fichnom,NF90_CLOBBER,nid))
+  CALL err(NF90_CREATE(fichnom,IOR(NF90_CLOBBER,NF90_64BIT_OFFSET),nid))
 
 !--- Some global attributes
Index: /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/conf_phys_m.F90	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/conf_phys_m.F90	(revision 4800)
@@ -2315,5 +2315,6 @@
     flag_aerosol=flag_aerosol_omp
     flag_aerosol_strat=flag_aerosol_strat_omp
-    flag_aer_feedback=flag_aer_feedback_omp
+    !flag_aer_feedback=flag_aer_feedback_omp
+    flag_aer_feedback=.FALSE. !Nicolas Février
     flag_bc_internal_mixture=flag_bc_internal_mixture_omp
     aer_type = aer_type_omp
Index: /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_mod.F90	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_mod.F90	(revision 4800)
@@ -501,5 +501,5 @@
                            tname(iiq),'Tracer '//ttext(iiq), "-",  &
                            (/ '', '', '', '', '', '', '', '', '', '' /))
-            o_dtr_vdf(iq-nqo) = ctrl_out((/ 4, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
+            o_dtr_vdf(iq-nqo) = ctrl_out((/ 5, 5, 5, 5, 10, 10, 11, 11, 11, 11 /), &
                               'd'//trim(tname(iq))//'_vdf',  &
                               'Tendance tracer '//ttext(iiq), "-" , &
@@ -566,5 +566,5 @@
                                  (/ '', '', '', '', '', '', '', '', '', '' /))
 
-            o_dtr_dry(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
+            o_dtr_dry(iq-nqo) = ctrl_out((/ 5, 5, 5, 5, 10, 10, 11, 11, 11, 11 /), &
                               'cum'//'d'//trim(tname(iq))//'_dry', &
                               'tracer tendency dry deposition'//ttext(iiq), "-", &
Index: /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_write_mod.F90	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/phys_output_write_mod.F90	(revision 4800)
@@ -413,5 +413,5 @@
     ! Local
     INTEGER :: itau_w
-    INTEGER :: i, iinit, iinitend=1, iff, iq, iiq, nsrf, k, ll, naero
+    INTEGER :: i, iinit, iinitend=1, iff, iq, iiq, nsrf, k, ll, naero, j
     REAL, DIMENSION (klon) :: zx_tmp_fi2d, zpt_conv2d, wind100m
     REAL, DIMENSION (klon,klev) :: zx_tmp_fi3d, zpt_conv
@@ -446,4 +446,6 @@
     REAL,DIMENSION(klon,klev) :: z, dz
     REAL,DIMENSION(klon)      :: zrho, zt
+
+    INTEGER,DIMENSION(2) :: index_bc=[106,116]
 
     ! On calcul le nouveau tau:
@@ -2368,5 +2370,5 @@
              CALL histwrite_phy(o_dtr_uscav(iq-nqo),d_tr_uscav(:,:,iq-nqo))
             !--2D fields
-             CALL histwrite_phy(o_dtr_dry(iq-nqo), flux_tr_dry(:,iq-nqo))
+             !CALL histwrite_phy(o_dtr_dry(iq-nqo), flux_tr_dry(:,iq-nqo))
              zx_tmp_fi2d=0.
              IF (vars_defined) THEN
@@ -2378,4 +2380,13 @@
            ENDDO !--iq
          ENDIF   !--type_trac
+
+         ! Pour bilan
+         DO j=1,size(index_bc)
+             iq=index_bc(j)
+            ! WRITE(lunout,*) "WRITE_TEST_1"," / iq=",iq
+             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
+             !WRITE(lunout,*) "WRITE_TEST_2"
+         END DO
+         
 !
          IF (type_trac == 'co2i') THEN
Index: /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/radlwsw_m.F90	(revision 4799)
+++ /LMDZ6/branches/SETHET_DECOUPLE/libf/phylmd/radlwsw_m.F90	(revision 4800)
@@ -873,5 +873,6 @@
          ZTOPLWAIAERO,ZSOLLWAIAERO, &
          ZLWADAERO, & !--NL
-         ok_ade, ok_aie, ok_volcan, flag_aerosol,flag_aerosol_strat, flag_aer_feedback) ! flags aerosols
+         !ok_ade, ok_aie, ok_volcan, flag_aerosol,flag_aerosol_strat, flag_aer_feedback) ! flags aerosols
+         ok_ade, ok_aie, ok_volcan, flag_aerosol,flag_aerosol_strat, .FALSE.) !Nicolas Février
             
 !        print *,'RADLWSW: apres RECMWF'