Index: /LMDZ6/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4807)
+++ /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4808)
@@ -825,4 +825,7 @@
         <field id="rsdcs"    long_name="SW CS downward radiation"    unit="W m-2" />
         <field id="rlucs"    long_name="LW CS upward radiation"    unit="W m-2" />
+	<field id="rsucs_s2"    long_name="SW CS upward radiation"    unit="W m-2" />
+        <field id="rsdcs_s2"    long_name="SW CS downward radiation"    unit="W m-2" />
+        <field id="rlucs_s2"    long_name="LW CS upward radiation"    unit="W m-2" />	
         <field id="rldcs4co2"    long_name="Downwelling CS LW 4xCO2 atmosphere"    unit="W/m2" />
         <field id="rlucs4co2"    long_name="Upwelling CS LW 4xCO2 atmosphere"    unit="W/m2" />
@@ -842,4 +845,9 @@
         <field id="rlu"    long_name="LW upward radiation"    unit="W m-2" />
         <field id="rld"    long_name="LW downward radiation"    unit="W m-2" />
+	<field id="rldcs_s2" long_name="LW CS downward radiation"    unit="W m-2" />
+	<field id="rsu_s2"    long_name="SW upward radiation"    unit="W m-2" />
+        <field id="rsd_s2"    long_name="SW downward radiation"    unit="W m-2" />
+        <field id="rlu_s2"    long_name="LW upward radiation"    unit="W m-2" />
+        <field id="rld_s2"    long_name="LW downward radiation"    unit="W m-2" />	
         <field id="kz"    long_name="Kz melange"    unit="m2/s" enabled="FALSE" />
         <field id="evu"    long_name="Eddy viscosity coefficient for Momentum Variables"    unit="m2 s-1" />
Index: /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4807)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4808)
@@ -238,5 +238,7 @@
          o_LWupSFCclr_s2, o_LWdnSFCclr_s2, o_SWupSFC_s2, &
          o_SWupSFCclr_s2, o_SWdnSFC_s2, o_SWdnSFCclr_s2, &
-         o_LWupSFC_s2, o_LWdnSFC_s2   
+         o_LWupSFC_s2, o_LWdnSFC_s2, , o_rlu_s2, o_rld_s2, &
+         o_rlucs_s2, o_rldcs_s2, o_rsu_s2, o_rsd_s2, &
+         o_rsucs_s2, o_rsdcs_s2   
 #endif
 
@@ -301,5 +303,5 @@
         toplw0_s2,toplw_s2,topsw0_s2,topsw_s2, &
         swup0_s2,swup_s2,swdn_s2,swdn0_s2,sollwdownclr_s2, &
-        sollwdown_s2,lwdn0_s2
+        sollwdown_s2,lwdn0_s2,lwup_s2,lwdn_s2,lwup0_s2,lwdn0_s2
     USE phys_output_var_mod, ONLY: cloud_cover_sw, &
         cloud_cover_sw_s2
@@ -1158,4 +1160,47 @@
        ENDIF
        CALL histwrite_phy(o_SWdnSFCclr_s2, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          zx_tmp_fi2d(:) = swdn_s2(:,1)*swradcorr(:)
+       ENDIF
+       CALL histwrite_phy(o_SWdnSFC_s2, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          zx_tmp_fi2d(:) = swdn0_s2(:,1)*swradcorr(:)
+       ENDIF
+       CALL histwrite_phy(o_SWdnSFCclr_s2, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+         DO k=1, klevp1
+           zx_tmp_fi3d1(:,k)=swup_s2(:,k)*swradcorr(:)
+         ENDDO
+       ENDIF
+       CALL histwrite_phy(o_rsu_s2, zx_tmp_fi3d1)
+
+       IF (vars_defined) THEN
+         DO k=1, klevp1
+           zx_tmp_fi3d1(:,k)=swdn_s2(:,k)*swradcorr(:)
+         ENDDO
+       ENDIF
+       CALL histwrite_phy(o_rsd_s2, zx_tmp_fi3d1)
+
+       IF (vars_defined) THEN
+         DO k=1, klevp1
+           zx_tmp_fi3d1(:,k)=swup0_s2(:,k)*swradcorr(:)
+         ENDDO
+       ENDIF
+       CALL histwrite_phy(o_rsucs_s2, zx_tmp_fi3d1)
+
+       IF (vars_defined) THEN
+         DO k=1, klevp1
+           zx_tmp_fi3d1(:,k)=swdn0_s2(:,k)*swradcorr(:)
+         ENDDO
+       ENDIF
+       CALL histwrite_phy(o_rsdcs_s2, zx_tmp_fi3d1)
+
+       CALL histwrite_phy(o_rlu_s2, lwup_s2)
+       CALL histwrite_phy(o_rld_s2, lwdn_s2)
+       CALL histwrite_phy(o_rlucs_s2, lwup0_s2)
+       CALL histwrite_phy(o_rldcs_s2, lwdn0_s2)
     ENDIF !ok_3Deffect
 #endif       